# debug info seem not works with D compiler
%global debug_package       %{nil}
%global snapdate            20180529
#%%global snapdate            20170807
%global msgpack_revision    f5c0bd0
#%%global msgpack_revision    5009409
%global alphatag            %{snapdate}git%{msgpack_revision}
%global major_version       1
%global minor_version       0
%global patch_version       0
%global pre                 beta.7

Name:           msgpack-d
Version:        %{major_version}.%{minor_version}.%{patch_version}
Release:        1.%{alphatag}%{?dist}
Summary:        MessagePack for D is a pure D implementation of MessagePack
Summary(fr):    MessagePack pour D est une implémentation en D de MessagePack

License:        Boost
URL:            https://github.com/msgpack/msgpack-d

# The source for this package was pulled from upstream's git.
# Use the following commands to generate the tarball:
# git clone https://github.com/msgpack/msgpack-d.git msgpack
# cd msgpack
# timestamp=$(git log -1 --date=short --pretty='format:%at')
# lastCommit=$(date -d @${timestamp} +'%Y%m%d')
# hashRevision=$(git rev-parse --short HEAD)
# git archive --prefix=msgpack-d-${lastCommit}git${hashRevision}/ HEAD --format=tar | xz > ../msgpack-d-${lastCommit}git${hashRevision}.tar.xz

Source0:        %{name}-%{alphatag}.tar.xz
ExclusiveArch:  %{ldc_arches}

BuildRequires:  ldc
Requires:       ldc-phobos ldc-druntime

%description
MessagePack is a binary-based JSON-like serialization library.

%description -l fr
MessagePack est une bibliothèque de sérialisation ressemblant à un format
JSON en binaire.

%package        devel
Summary:        Development files for %{name}
Summary(fr):    Fichiers de développement pour %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description devel
msgpack-d-devel package contains header files for developing D applications
that use msgpack-d.

%description devel -l fr
Le paquet msgpack-d-devel contient les fichiers d'entêtes pour développer
des applications en D utilisant msgpack-d.


%package geany-tags
Summary:        Support for enable autocompletion in geany
Summary(fr):    Support pour activer l'auto-complétion dans geany
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch
BuildRequires:  geany
Requires:       geany

%description geany-tags
Enable autocompletion for msgpack-d library in geany (IDE)

%description -l fr geany-tags
Active l'autocompletion pour pour la bibliothèque msgpack-d dans geany (IDE)

%prep
%setup -q -n %{name}-%{alphatag}
# temp geany config directory for allow geany to generate tags
mkdir geany_config

echo "# Package Information for pkg-config
# Author: 
# Created: $(date)
# Licence: Boost
prefix=%{_prefix}
exec_prefix=%{_prefix}
libdir=%{_libdir}
includedir=%{_d_includedir}/
Name: %{name}
Description: MessagePack is a binary-based JSON-like serialization library.
Version: %{version}
Libs: -L-l%{name}
Cflags: -I %{_d_includedir}/%{name} ${DFLAGS}" > %{name}.pc

# Inconsistent line ending https://github.com/msgpack/msgpack-d/issues/105
find example -name '*.d' -print0 | xargs -0 -I dfile sed -i 's/\r//g' dfile 
for dosfile in html/candydoc/candy.ddoc html/candydoc/modules.ddoc html/candydoc/tree.js html/candydoc/util.js; do
    sed -i 's/\r//g' "${dosfile}"
done

%build
DFLAGS='-w -release -g -O2'

src_dir='src'
sources=$(find "${src_dir}" -name '*.d')
LIBS='-L-ldl -L-ldruntime-ldc-shared  -L-lphobos2-ldc-shared'
mkdir build
for f in ${sources[@]}; do
    d_path=$(dirname ${f});
    d_file=$(basename ${f});
    header_file=include/${d_path/${src_dir}}/${d_file/.d/.di}
    doc_file=html/${d_path/${src_dir}}/${d_file/.d/.html}
    object_file=build/${d_path/${src_dir}}/${d_file/.d/.o}
    # generate header
    ldc2 -I "${src_dir}" -o- -c $f -Hf ${header_file};
    # generate doc
    ldc2 -I "${src_dir}" -o- -c $f -Df ${doc_file} html/candydoc/candy.ddoc html/candydoc/modules.ddoc;
    # generate object
    ldc2 -I "${src_dir}" ${DFLAGS} -c -relocation-model=pic $f -of ${object_file}
done
# generate library
objects=$(find build -name '*.o')
ldc2 ${LIBS} -L-Wl,-z,relro -L-Wl,-z,now -shared -soname lib%{name}.so.%{major_version} -of./lib/lib%{name}.so.%{version} ${objects}


# generate geany tags
geany -c geany_config -g %{name}.d.tags ${sources[@]} 


%install
mkdir -p %{buildroot}/{%{_libdir},%{_d_includedir}/msgpack,%{_datadir}/geany/tags/}

# header files
# FIXME: https://github.com/ldc-developers/ldc/issues/2797
#cp include/*.di %%{buildroot}/%%{_d_includedir}/msgpack
sources=$(find src -name '*.d')
cp ${sources[@]}  %{buildroot}/%{_d_includedir}/msgpack

# shared library
install -m0755 lib/lib%{name}.so.%{version} %{buildroot}/%{_libdir}
pushd %{buildroot}/%{_libdir}
    ln -s lib%{name}.so.%{version} lib%{name}.so.%{major_version}
    ln -s lib%{name}.so.%{major_version} lib%{name}.so
popd

# geany tags
install -m0644 %{name}.d.tags %{buildroot}/%{_datadir}/geany/tags/

# pkgconfig
install -d %{buildroot}/%{_datadir}/pkgconfig
install -m 0644 %{name}.pc %{buildroot}/%{_datadir}/pkgconfig


%ldconfig_scriptlets

%files
%license LICENSE_1_0.txt
%doc README.markdown
%{_libdir}/lib%{name}.so.%{version}
%{_libdir}/lib%{name}.so.%{major_version}

%files devel
%doc html example
%{_datadir}/pkgconfig/%{name}.pc
%{_includedir}/d/msgpack
%{_libdir}/lib%{name}.so

%files geany-tags
%{_datadir}/geany/tags/%{name}.d.tags

%changelog
* Wed Aug  1 2018 MERCIER Jonathan <bioinfornatics at gmail.com> - 1.0.0-1.20180529gitf5c0bd0
- Initial release
